#!/bin/bash
#
# Description: 配列展開と操作の基本パターン

source pre.bash

echo '文字数と長さ'

function array_basic() {
    [ ${BASH_VERSION%%.*} -ge 4 ] && echo ${array[@]@A}
    echo "\${array[@]} => ${array[@]}"
    echo
    echo "\${#array} => ${#array}"                # String length of the 1st element
    echo "\${#array[1]} => ${#array[1]}"          # String length of the Nth element
    echo "\${#array[@]} => ${#array[@]}"          # Number of elements
    echo
}

array=(This is a pen.)
array_basic

array=(これは、 ペン です。)
array_basic

echo '要素の追加と削除'
[ ${BASH_VERSION%%.*} -ge 4 ] && echo ${array[@]@A}
echo "\${array[@]} => ${array[@]}"
echo
echo 'array[3]="ゴリラ"'
array[3]="ゴリラ"
[ ${BASH_VERSION%%.*} -ge 4 ] && echo ${array[@]@A}
echo "\${array[@]} => ${array[@]}"
echo
[ ${BASH_VERSION%%.*} -ge 4 ] && echo ${array[@]@A}
echo 'array+=(これは、 りんご です。)'
array+=(これは、 りんご です。)
[ ${BASH_VERSION%%.*} -ge 4 ] && echo ${array[@]@A}
echo "\${array[@]} => ${array[@]}"
echo

echo 'unset array[1]'
unset array[1]
[ ${BASH_VERSION%%.*} -ge 4 ] && echo ${array[@]@A}
echo "\${array[@]} => ${array[@]}"
echo

echo 'unset array'
unset array
[ ${BASH_VERSION%%.*} -ge 4 ] && echo ${array[@]@A}
echo "\${array[@]} => ${array[@]}"

