#!/bin/bash
#
# Description: 配列展開の基本パターン3
#              文字列の加工2: 基本の切り出し, 位置指定による切り出し

source pre.bash

echo "文字列の加工2"
echo

function array_cut() {
    echo "    マッチングによる切り出し"
    [ ${BASH_VERSION%%.*} -ge 4 ] && echo ${array[@]@A}
    echo "    \${array[@]} => ${array[@]}"
    echo
    echo "    \${array[@]#$1} => ${array[@]#$1}"
    echo "    \${array[@]%$1} => ${array[@]%$1}"
    echo "    \${array[@]#*$1} 先頭からはじめに「$1」にマッチするところまで削除:" " '${array[@]#*$1}'" 
    echo "    \${array[@]##*$1} 先頭から最後に「$1」にマッチするところまで削除:" " '${array[@]##*$1}'" 
    echo "    \${array[@]%$1*} 末尾からはじめに「$1」にマッチするところまで削除:" " '${array[@]%$1*}'" 
    echo "    \${array[@]%%$1*} 末尾から最後に「$1」にマッチするところまで削除:" " '${array[@]%%$1*}'" 
    echo
    echo "    \${array[*]#$1} => ${array[*]#$1}"
    echo "    \${array[*]%$1} => ${array[*]%$1}"
    echo "    \${array[*]#*$1} 先頭からはじめに「$1」にマッチするところまで削除:" " '${array[*]#*$1}'" 
    echo "    \${array[*]##*$1} 先頭から最後に「$1」にマッチするところまで削除:" " '${array[*]##*$1}'" 
    echo "    \${array[*]%$1*} 末尾からはじめに「$1」にマッチするところまで削除:" " '${array[*]%$1*}'" 
    echo "    \${array[*]%%$1*} 末尾から最後に「$1」にマッチするところまで削除:" " '${array[*]%%$1*}'" 
    echo '    # % の後ろがパターン。パターン中*は任意の文字列。マッチング記号2つは、最長マッチと
いうこと'
    echo
}

function array_cut_position() {
    echo "    位置指定による切り出し"
    echo '        開始位置は、「0」から数える。${str::2} ${str:2} のように省略した部分は0とみなす'
    #[ ${BASH_VERSION%%.*} -ge 4 ] && echo ${array[@]@A}
    echo "    \${array[@]} => ${array[@]}"
    echo "    \${array[0]:1:2} => ${array[0]:1:2}"
    echo "    \${array[@]:1:2} => ${array[@]:1:2}"     # Range (from position 1, length 2)
    echo
}

array=(This is a pen.)
array_cut "is"

array=(I have a pen. You have a pencil. She has a dog.)
array_cut "en"
array_cut_position

array=(これは、 ペン です。 ペンギン 大好き。)
array_cut "ペン"
array_cut_position
