#!/bin/bash
#
# Description: 配列展開の基本パターン4
#              文字列の加工3: 置換と削除

source pre.bash

echo "文字列の加工3"
echo 'パターンには、任意の文字列*、任意の1文字?、文字クラス[]などがあるが、ここではその1部分をとりあげる'

function array_substitution() {
    echo "    置換と削除"
    [ ${BASH_VERSION%%.*} -ge 4 ] && echo ${array[@]@A}
    echo

    echo "    \${array[$3] => ${array[$3]}"
    echo "    \${array[$3]/$1/$2} => ${array[$3]/$1/$2}"
    echo "    \${array[$3]//$1/$2} => ${array[$3]//$1/$2}"
    echo

    echo "    \${array[@] => ${array[@]}"
    echo "    \${array[@]/$1/$2} => ${array[@]/$1/$2}"
    echo "    \${array[@]//$1/$2} => ${array[@]//$1/$2}"
    echo
}

array=(This pen is in an inn.)
array_substitution "n" "S" 3

array=(これは、 ペン ですネンテン。)
array_substitution "ン" "ット" 2

