#!/bin/bash
#
# Description: 連想配列の操作

declare -A aa # 宣言したほうが、初回代入時などに通常配列とご認識されないのでよい
aa=(["El primo"]="1番目の要素 uno" ["El segundo"]="二番目の要素 dos" ["El tercero"]="Third element tres")

[ ${BASH_VERSION%%.*} -ge 4 ] && echo ${aa[@]@A}
echo "\${aa[@]} => ${aa[@]}"
echo

echo "配列の長さ"
echo "\${aa[@]} => ${aa[@]}"
echo "\${#aa[@]} => ${#aa[@]}"
echo

echo "\${aa[*]} => ${aa[*]}"
echo "\${#aa[*]} => ${#aa[*]}"
echo

echo "forを使って要素を1つずつ扱う"
# @と*の違いは、ここに注目
echo '-- for element in ${aa[@]}'
for e in ${aa[@]} ; do echo $e; done
echo

echo '-- for element in "${aa[@]}"'
for e in "${aa[@]}" ; do echo $e; done
echo

echo '-- for element in ${aa[*]}'
for e in "${aa[*]}" ; do echo $e; done
echo

echo '-- for element in "${aa[*]}"'
for e in "${aa[*]}" ; do echo $e; done
echo

echo '-- !を用いることで、キーを取得できる。--'
echo "\${!aa[@]} => ${!aa[@]}"
echo '-- for key in ${!aa[@]}'
for i in "${!aa[@]}" ; do echo $i; done
echo

echo "\${!aa[*]} => ${!aa[*]}"
echo '-- for key in ${!aa[*]}'
for i in "${!aa[*]}" ; do echo $i; done
echo

echo "連想配列への要素の追加と削除"
echo 'aa+=(["The fourth"]="四番目の要素")'
aa+=(["The fourth"]="四番目の要素")
[ ${BASH_VERSION%%.*} -ge 4 ] && echo ${aa[@]@A}
echo "\${aa[@]} => ${aa[@]}"
echo

echo 'unset aa["El segundo"]'
unset aa["El segundo"]
[ ${BASH_VERSION%%.*} -ge 4 ] && echo ${aa[@]@A}
echo "\${aa[@]} => ${aa[@]}"
echo

echo 'unset aa'
unset aa
[ ${BASH_VERSION%%.*} -ge 4 ] && echo ${aa[@]@A}
echo "\${aa[@]} => ${aa[@]}"
echo
