#!/bin/bash
#
# Description: 変数展開の基本パターン7
#              変形と変数の情報の取得

source pre.bash

echo "変換と変数の情報の取得 (bash4)"
echo '${parameter@operator}の形'

[ ${BASH_VERSION%%.*} -lt 4 ] && echo "Bash Version 4以降の機能" && exit

echo "  変形 (変数のメタレベル操作)"
parameter='This is a pen.\tI am a boy.\n\[\e[0;36m\](\h@\w)\$\[\e[0;0m\] ' 
echo "  parameter=${parameter@Q}"

echo '  ${parameter@Q} 文字列をクォート: '
echo "      「${parameter@Q}」"
echo '  ${parameter@E} バックスラッシュエスケープシーケンスを展開: '
echo "      「${parameter@E}」"
echo '  ${parameter@P} 文字列がプロンプト文字列だったら展開: '
echo "      「${parameter@P}」"
echo '  ${parameter@A} 代入文または宣言コマンドの形式の文字列で、その属性と値を使用してパラメータを再作成:'
echo "      「${parameter@A}」"
echo '  ${parameter@a} パラメータ属性を表すフラグ値で構成される文字列:  '
echo "      「${parameter@a}」"
echo

unset parameter
echo 'declare -i parameter=10'
declare -i parameter=10
echo '  ${parameter@A} 代入文または宣言コマンドの形式の文字列で、その属性と値を使用してパラメータを再作成:'
echo "      「${parameter@A}」"
echo '  ${parameter@a} パラメータ属性を表すフラグ値で構成される文字列:  '
echo "      「${parameter@a}」"
echo

unset parameter
echo 'declare -a parameter=(10 20)'
declare -a parameter=(10 20)
echo '  ${parameter@A} 代入文または宣言コマンドの形式の文字列で、その属性と値を使用してパラメータを再作成:'
echo "      「${parameter@A}」"
echo '  ${parameter@a} パラメータ属性を表すフラグ値で構成される文字列:  '
echo "      「${parameter@a}」"
echo
echo '  ${parameter[@]@A} 代入文または宣言コマンドの形式の文字列で、その属性と値を使用してパラメータを再作成:'
echo "      「${parameter[@]@A}」"
echo '  ${parameter[@]@a} パラメータ属性を表すフラグ値で構成される文字列:  '
echo "      「${parameter[@]@a}」"
echo

unset parameter
echo 'declare -ai parameter=(10 20)'
declare -ai parameter=(10 20)
echo '  ${parameter[@]@A} 代入文または宣言コマンドの形式の文字列で、その属性と値を使用してパラメータを再作成:'
echo "      「${parameter[@]@A}」"
echo '  ${parameter[@]@a} パラメータ属性を表すフラグ値で構成される文字列:  '
echo "      「${parameter[@]@a}」"

